/*
PWM values looping through array + user input.
 
 J Richards 2016
 
 */

int pwmPin = 9;    // PWM output pin 9
int user_input[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; // user generated sequence
int current_index = 0;
int array_length = 0;           // length of the array

//voice input value
int seqPin = A0;    // select the input pin for the pot
int seqValue = 0;  // variable to store the value coming from the pot

//analog tempo control
int tempoPin = A7;    // select the input pin for the pot
int tempoValue = 0;  // variable to store the value coming from the pot

// set pin numbers:
int buttonPin = 3;     // the number of the pushbutton pin
int buttonState = 0; 

unsigned long previousMillis = 0;        // will store last time tempo was updated

void setup()  { 
  // nothing happens in setup
  //TCCR0B = 0x01;   // Timer 0: PWM 5 &  6 @ 16 kHz
  TCCR1B = 0x01;   // Timer 1: PWM 9 & 10 @ 32 kHz
  TCCR2B = 0x01;   // Timer 2: PWM 3 & 11 @ 32 kHz

  // initialize the pushbutton pin as an input:
  pinMode(buttonPin, INPUT);
} 

void loop() {

  analogWrite(pwmPin, user_input [current_index] / 4); // analogRead values go from 0 to 1023, analogWrite values from 0 to 255

  unsigned long currentMillis = millis();

  // read the state of the pushbutton value:
  buttonState = digitalRead(buttonPin);

  // read the value from tempo control:
  tempoValue = analogRead(tempoPin);

  // read the value from sequencer input:
  user_input[array_length] = analogRead(seqPin);

  if (buttonState == HIGH) {
    delay(40); // debounce
    delay(40); // debounce again
    if (buttonState == HIGH)// if still pressed
      array_length++; // now increment to the next space in the array
    delay(40); // debounce
    if (array_length >= 16)
      array_length = 0; // if we reach the end of the array, go back to the start
  }

  if (currentMillis - previousMillis >= tempoValue) {
    previousMillis = currentMillis;   
    current_index++;
  }
  if (current_index > array_length) {
    current_index = 0;
  }     
}
